Public Class MoveButton

    Private m_MustMoveUp As Boolean = False
    Private m_ClassToMove As Imovable
    Private m_Direction As MoveDirections
    ReadOnly Property Direction() As MoveDirections
        Get
            Return m_Direction
        End Get
    End Property
    ReadOnly Property ClassToMove() As Imovable
        Get
            Return m_ClassToMove
        End Get
    End Property
    Public Sub New(ByVal Direction As MoveDirections, ByVal ClassToMove As Imovable)

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()
        m_Direction = Direction
        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        If Direction = MoveDirections.Down Then
            Me.Image = My.Resources.SmallMoveDown
            If Not ClassToMove.CanMoveDown Then
                Me.Enabled = False
            End If

        ElseIf Direction = MoveDirections.Left Then
            Me.Image = My.Resources.SmallMoveLeft
            m_MustMoveUp = True
            If Not ClassToMove.CanMoveUp Then
                Me.Enabled = False
            End If
        ElseIf Direction = MoveDirections.Right Then
            Me.Image = My.Resources.SmallMoveRight
            If Not ClassToMove.CanMoveDown Then
                Me.Enabled = False
            End If
        ElseIf Direction = MoveDirections.Up Then
            Me.Image = My.Resources.SmallMoveTop
            m_MustMoveUp = True
            If Not ClassToMove.CanMoveUp Then
                Me.Enabled = False
            End If
        End If
        m_ClassToMove = ClassToMove
        Me.Size = New Size(16, 16)
    End Sub

    Private Sub MoveButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        m_ClassToMove.IsMovedGroup = True
        If m_MustMoveUp Then
            m_ClassToMove.MoveUp()
        Else
            m_ClassToMove.MoveDown()
        End If
        m_ClassToMove.IsMovedGroup = False
    End Sub

    'Public Sub RefreshValues()
    '    If m_Direction = MoveDirections.Down OrElse m_Direction = MoveDirections.Right Then
    '        If Not m_ClassToMove.CanMoveDown Then
    '            Me.Enabled = False
    '        Else
    '            Me.Enabled = True
    '        End If

    '    ElseIf m_Direction = MoveDirections.Left OrElse m_Direction = MoveDirections.Up Then
    '        If Not m_ClassToMove.CanMoveUp Then
    '            Me.Enabled = False
    '        Else
    '            Me.Enabled = True
    '        End If
    '    End If
    'End Sub
End Class
