Public Class Form1
    Private WithEvents m_Builder As LaborTextBuilder
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        m_Builder = New LaborTextBuilder
        SetTestValues()
        Me.LaborPanel1.Source = m_Builder
        Me.TextBox1.Text = m_Builder.Text
    End Sub

    Private Sub m_Builder_Text_Changed() Handles m_Builder.Text_Changed
        Me.TextBox1.Text = m_Builder.Text
    End Sub

    Private Sub SetTestValues()
        m_Builder.SetWert("HB", "12,8")
        m_Builder.SetWert("BSG", "68")
        m_Builder.SetWert("CRP", "121")
        m_Builder.SetWert("K", "2,5")
        m_Builder.SetWert("ALAT", "5,62")
        m_Builder.SetWert("ASAT", "5,18")
        m_Builder.SetWert("BiliG", "125")
        m_Builder.SetWert("CK", "4,8")
        m_Builder.SetWert("CKMB", "1,2")
        m_Builder.SetWert("TSH", "ok")
        m_Builder.SetWert("ULeu", "100")
        m_Builder.SetGroupNormal("Blutbild")
        m_Builder.SetGroupNormal("Urinstatus")
        m_Builder.SetGroupNormal("Elektrolyte")
        m_Builder.SetGroupNormal("Differentialblutbild")
        m_Builder.SetGroupNormal("Pankreasenzyme")
        m_Builder.SetGroupNormal("Infarktenzyme")
    End Sub
End Class
