Public Class UrinStatusGruppe
    Inherits LaborTextGruppeGemeinsamWert


    Public Sub New(ByVal Builder As LaborTextBuilder)
        MyBase.New("Urinstatus", Builder)
        Me.Werte.Add(New LaborWert("ULeu", "Leukozyten", Me))
        Me.Werte.Add(New LaborWert("UEry", "Erythrozyten", Me))
        Me.Werte.Add(New LaborWert("UBilin", "Urobilinogen", Me))

    End Sub

    Public Overrides Function GetWeiteresLabel() As String
        Return "weiterer Urinstatus"
    End Function

    Public Overrides Function PathologischTexte() As System.Collections.Generic.List(Of String)
        Dim Result As New List(Of String)

        Dim TmpTexte As New List(Of String)

        For Each Wt As LaborWert In Me.Werte
            If Wt.Wert <> "" Then
                TmpTexte.Add(Wt.LangText & " " & Wt.Wert)
            End If
        Next

        If TmpTexte.Count > 0 Then
            Dim Txt As String = Join(TmpTexte.ToArray, ", ")
            Txt = "im Urinstatus " & Txt
            Result.Add(Txt)
        End If

        Return Result
    End Function

End Class
